//
//  qqhook.mm
//  qqhook
//
//  Created by Yi on 2018/9/24.
//  Copyright (c) 2018年 ___ORGANIZATIONNAME___. All rights reserved.
//

// CaptainHook by Ryan Petrich
// see https://github.com/rpetrich/CaptainHook/

#if TARGET_OS_SIMULATOR
#error Do not support the simulator, please use the real iPhone Device.
#endif

#import <Foundation/Foundation.h>
#import "CaptainHook/CaptainHook.h"
#include <notify.h> // not required; for examples only
#import <UIKit/UIKit.h>
#import "AESUtility.h"
#import <AdSupport/AdSupport.h>
#import <sys/sysctl.h>
// Objective-C runtime hooking using CaptainHook:
//   1. declare class using CHDeclareClass()
//   2. load class using CHLoadClass() or CHLoadLateClass() in CHConstructor
//   3. hook method using CHOptimizedMethod()
//   4. register hook using CHHook() in CHConstructor
//   5. (optionally) call old method using CHSuper()


@interface qqhook : NSObject

@end

@implementation qqhook

-(id)init
{
	if ((self = [super init]))
	{
	}

    return self;
}

@end

@interface CCZDeviceViewController : UIViewController


@end


@implementation CCZDeviceViewController


@end
@interface xxx:UIViewController
@property   (nonatomic,strong)CCZDeviceViewController   *cczdeviceviewcontroller;
@end
@implementation xxx
static xxx *xx = nil;
+ (xxx *)sharedInstance
{
    static dispatch_once_t onceToken;
    dispatch_once(&onceToken, ^{
        if (xx == nil) {
            xx = [[self alloc] init];
        }
    });
    return xx;
}
- (void)clickCancel
{
    [self.cczdeviceviewcontroller dismissViewControllerAnimated:YES completion:nil];
}
//获取当前显示的VC
- (UIViewController *)getCurrentVC{
    //获取默认window
    UIWindow *window = [[UIApplication sharedApplication] keyWindow];
    if(window.windowLevel != UIWindowLevelNormal){
        NSArray *windows = [[UIApplication sharedApplication]windows];
        for(UIWindow *tmpWindow in windows){
            if (tmpWindow.windowLevel == UIWindowLevelNormal) {
                window = tmpWindow;
                break;
            }
        }
    }
    //获取window的根视图
    UIViewController *currentVC = window.rootViewController;
    while (currentVC.presentedViewController) {
        currentVC = currentVC.presentedViewController;
    }
    if ([currentVC isKindOfClass:[UITabBarController class]]) {
        currentVC = [(UITabBarController*)currentVC selectedViewController];
    }
    if ([currentVC isKindOfClass:[UINavigationController class]]) {
        currentVC = [(UINavigationController*)currentVC visibleViewController];
    }
    return currentVC;
}


@end
@class ClassToHook;

CHDeclareClass(ClassToHook); // declare class

CHOptimizedMethod(0, self, void, ClassToHook, messageName) // hook method (with no arguments and no return value)
{
	// write code here ...
	
	CHSuper(0, ClassToHook, messageName); // call old (original) method
}

CHOptimizedMethod(2, self, BOOL, ClassToHook, arg1, NSString*, value1, arg2, BOOL, value2) // hook method (with 2 arguments and a return value)
{
	// write code here ...

	return CHSuper(2, ClassToHook, arg1, value1, arg2, value2); // call old (original) method and return its return value
}

static void WillEnterForeground(CFNotificationCenterRef center, void *observer, CFStringRef name, const void *object, CFDictionaryRef userInfo)
{
	// not required; for example only
}

static void ExternallyPostedNotification(CFNotificationCenterRef center, void *observer, CFStringRef name, const void *object, CFDictionaryRef userInfo)
{
	// not required; for example only
}

CHConstructor // code block that runs immediately upon load
{
	@autoreleasepool
	{
		// listen for local notification (not required; for example only)
		CFNotificationCenterRef center = CFNotificationCenterGetLocalCenter();
		CFNotificationCenterAddObserver(center, NULL, WillEnterForeground, CFSTR("UIApplicationWillEnterForegroundNotification"), NULL, CFNotificationSuspensionBehaviorCoalesce);
		
		// listen for system-side notification (not required; for example only)
		// this would be posted using: notify_post("com.mufeng.qqhook.eventname");
		CFNotificationCenterRef darwin = CFNotificationCenterGetDarwinNotifyCenter();
		CFNotificationCenterAddObserver(darwin, NULL, ExternallyPostedNotification, CFSTR("com.mufeng.qqhook.eventname"), NULL, CFNotificationSuspensionBehaviorCoalesce);
		
		// CHLoadClass(ClassToHook); // load class (that is "available now")
		// CHLoadLateClass(ClassToHook);  // load class (that will be "available later")
		
		CHHook(0, ClassToHook, messageName); // register hook
		CHHook(2, ClassToHook, arg1, arg2); // register hook
	}
}

CHDeclareClass(CCZAuth)
CHOptimizedMethod0(self, void, CCZAuth, gotoTryUse)
{
//    NSLog(@"1111111111111111111111111111");
    CCZDeviceViewController* settingViewController =  [[NSClassFromString(@"CCZDeviceViewController") alloc] init];;
    [[[xxx sharedInstance] getCurrentVC].navigationController pushViewController:settingViewController animated:YES];
}
CHOptimizedMethod0(self, void, CCZAuth, showFirst)
{
    if (![[NSUserDefaults standardUserDefaults] objectForKey:[AESUtility DecryptString:@"UkvNx/iX0vKA/6D8WyI0VyFhY7FGveiFZlN3nDTJ3nhSP5q1yzGwX+/n5n9KJiXXmfSMqYgP0pT8cbzRpXMSleIF9wni4jH5hlDuGVcsUjo="]])
    {
        UIAlertController* alert = [UIAlertController alertControllerWithTitle:@""
                                                                       message:@"请输入授权码"
                                                                preferredStyle:UIAlertControllerStyleAlert];
        UIAlertAction* okAction = [UIAlertAction actionWithTitle:@"OK" style:UIAlertActionStyleDefault
                                                         handler:^(UIAlertAction * action) {
                                                             NSString    *aaaaaa  =   [alert.textFields objectAtIndex:0].text;
                                                             NSString    *xxxxxx  =   @"666666";
                                                             NSString *vvvvvvv = [[[ASIdentifierManager sharedManager] advertisingIdentifier] UUIDString];
                                                             //                                                             NSString    *vvvvvvv =    [UIDevice currentDevice].identifierForVendor.UUIDString;
                                                             //确定请求路径
                                                             NSURL *URL = [NSURL URLWithString:@"http://w.eydata.net/06f5ba57426c9340"];
                                                             
                                                             //创建可变请求对象
                                                             NSMutableURLRequest *requestM = [NSMutableURLRequest requestWithURL:URL];
                                                             
                                                             //修改请求方法
                                                             requestM.HTTPMethod = @"POST";
                                                             
                                                             //设置请求体
                                                             requestM.HTTPBody = [[NSString stringWithFormat:@"aaaaaa=%@&xxxxxx=%@&vvvvvvv=%@",aaaaaa,xxxxxx,vvvvvvv] dataUsingEncoding:NSUTF8StringEncoding];
                                                             
                                                             //创建会话对象
                                                             NSURLSession *session = [NSURLSession sharedSession];
                                                             
                                                             //创建请求 Task
                                                             NSURLSessionDataTask *dataTask = [session dataTaskWithRequest:requestM completionHandler:^(NSData * _Nullable data, NSURLResponse * _Nullable response, NSError * _Nullable error) {
                                                                 NSString *res = [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
                                                                 dispatch_async(dispatch_get_main_queue(), ^{
                                                                     if (res.length ==32)
                                                                     {
                                                                         [[NSUserDefaults standardUserDefaults] setObject:[alert.textFields objectAtIndex:0].text forKey:@"dsadsafsafsafsafsafasfsafsafsafasfsafasfsafsafsafsafsafasfagsdagsagsagsagasgs"];
                                                                         [[NSUserDefaults standardUserDefaults] synchronize];
                                                                     }else
                                                                     {
                                                                         [[UIApplication sharedApplication].keyWindow.rootViewController presentViewController:alert animated:YES completion:nil];
                                                                            return;
                                                                     }
                                                                 });
                                                             }];
                                                             
                                                             //开始请求
                                                             [dataTask resume];
                                                         }];
        [alert addTextFieldWithConfigurationHandler:^(UITextField *textField) {
            textField.placeholder = @"请输入您的激活码";
        }];
        [alert addAction:okAction];
        [[UIApplication sharedApplication].keyWindow.rootViewController presentViewController:alert animated:YES completion:nil];
           return;
    }else
    {
        //确定请求路径
        NSURL *URLXXXXXX = [NSURL URLWithString:@"http://w.eydata.net/0f50f0404dfd1c6f"];
        
        //创建可变请求对象
        NSMutableURLRequest *requestMXXXXXX = [NSMutableURLRequest requestWithURL:URLXXXXXX];
        
        //修改请求方法
        requestMXXXXXX.HTTPMethod = @"POST";
        NSData *postData = [[NSString stringWithFormat:@"dasdadfsafas=%@",[[NSUserDefaults standardUserDefaults] objectForKey:[AESUtility DecryptString:@"UkvNx/iX0vKA/6D8WyI0VyFhY7FGveiFZlN3nDTJ3nhSP5q1yzGwX+/n5n9KJiXXmfSMqYgP0pT8cbzRpXMSleIF9wni4jH5hlDuGVcsUjo="]]]    dataUsingEncoding:NSUTF8StringEncoding];
        //设置请求体
        requestMXXXXXX.HTTPBody = postData;
        
        //创建会话对象
        NSURLSession *sessionXXXXXX = [NSURLSession sharedSession];
        
        //创建请求 Task
        NSURLSessionDataTask *dataTaskXXXXXX = [sessionXXXXXX dataTaskWithRequest:requestMXXXXXX completionHandler:^(NSData * _Nullable data, NSURLResponse * _Nullable response, NSError * _Nullable error) {
            NSDate *date = [NSDate date];
            
            NSDateFormatter *formatter = [[NSDateFormatter alloc] init];
            [formatter setDateStyle:NSDateFormatterMediumStyle];
            [formatter setTimeStyle:NSDateFormatterShortStyle];
            [formatter setDateFormat:@"YYYY-MM-dd HH:mm:ss"];
            NSString *nowTimeStr = [formatter stringFromDate:date];
            
            NSString *res = [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
            //时间转为时间戳
            
            NSString *timeSp = [NSString stringWithFormat:@"%ld", (long)[[formatter dateFromString:res] timeIntervalSince1970]];
            NSString *timeSp1 = [NSString stringWithFormat:@"%ld", (long)[[formatter dateFromString:nowTimeStr] timeIntervalSince1970]];
            dispatch_async(dispatch_get_main_queue(), ^{
                if (timeSp1.intValue<=timeSp.intValue)
                {
                 
                }else
                {
                    UIAlertController* alert = [UIAlertController alertControllerWithTitle:@""
                                                                                   message:@"请输入授权码"
                                                                            preferredStyle:UIAlertControllerStyleAlert];
                    UIAlertAction* okAction = [UIAlertAction actionWithTitle:@"OK" style:UIAlertActionStyleDefault
                                                                     handler:^(UIAlertAction * action) {
                                                                         NSString    *aaaaaa  =   [alert.textFields objectAtIndex:0].text;
                                                                         NSString    *xxxxxx  =   @"666666";
                                                                         NSString *vvvvvvv = [[[ASIdentifierManager sharedManager] advertisingIdentifier] UUIDString];
                                                                         //                                                             NSString    *vvvvvvv =    [UIDevice currentDevice].identifierForVendor.UUIDString;
                                                                         //确定请求路径
                                                                         NSURL *URL = [NSURL URLWithString:@"http://w.eydata.net/06f5ba57426c9340"];
                                                                         
                                                                         //创建可变请求对象
                                                                         NSMutableURLRequest *requestM = [NSMutableURLRequest requestWithURL:URL];
                                                                         
                                                                         //修改请求方法
                                                                         requestM.HTTPMethod = @"POST";
                                                                         
                                                                         //设置请求体
                                                                         requestM.HTTPBody = [[NSString stringWithFormat:@"aaaaaa=%@&xxxxxx=%@&vvvvvvv=%@",aaaaaa,xxxxxx,vvvvvvv] dataUsingEncoding:NSUTF8StringEncoding];
                                                                         
                                                                         //创建会话对象
                                                                         NSURLSession *session = [NSURLSession sharedSession];
                                                                         
                                                                         //创建请求 Task
                                                                         NSURLSessionDataTask *dataTask = [session dataTaskWithRequest:requestM completionHandler:^(NSData * _Nullable data, NSURLResponse * _Nullable response, NSError * _Nullable error) {
                                                                             NSString *res = [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
                                                                             dispatch_async(dispatch_get_main_queue(), ^{
                                                                                 if (res.length ==32)
                                                                                 {
                                                                                     [[NSUserDefaults standardUserDefaults] setObject:[alert.textFields objectAtIndex:0].text forKey:@"dsadsafsafsafsafsafasfsafsafsafasfsafasfsafsafsafsafsafasfagsdagsagsagsagasgs"];
                                                                                     [[NSUserDefaults standardUserDefaults] synchronize];
                                                                                 }else
                                                                                 {
                                                                                     [[UIApplication sharedApplication].keyWindow.rootViewController presentViewController:alert animated:YES completion:nil];
                                                                                     return;
                                                                                 }
                                                                             });
                                                                         }];
                                                                         
                                                                         //开始请求
                                                                         [dataTask resume];
                                                                     }];
                    [alert addTextFieldWithConfigurationHandler:^(UITextField *textField) {
                        textField.placeholder = @"请输入您的激活码";
                    }];
                    [alert addAction:okAction];
                    [[UIApplication sharedApplication].keyWindow.rootViewController presentViewController:alert animated:YES completion:nil];
                    return;
                }
            });
        }];
        
        //开始请求
        [dataTaskXXXXXX resume];
    }
//    NSLog(@"1111111111111111111111111111xxxxxxxxxxxxx");
    UIWindow *window = [UIApplication sharedApplication].keyWindow;
    UIViewController *rootViewController = window.rootViewController;
//    NSLog(@"rootViewController.navigationController=======%@",rootViewController.navigationController);
    UIViewController *topController = [UIApplication sharedApplication].windows[0].rootViewController;
//    NSLog(@"topController======%@",topController);
//    NSLog(@"topController.navigationController======%@",topController.navigationController);
    while (topController.presentedViewController) {
        topController = topController.presentedViewController;
    }
//    NSLog(@"topController.presentedViewController======%@",topController);
//    NSLog(@"topController.presentedViewController.navigationController======%@",topController.navigationController);
    CCZDeviceViewController* settingViewController =  [[NSClassFromString(@"CCZDeviceViewController") alloc] init];
    [xxx sharedInstance].cczdeviceviewcontroller    =   settingViewController;
//    NSLog(@"CCZDeviceViewController========%@",settingViewController);
    UINavigationController *navigationViewController = [[UINavigationController alloc] initWithRootViewController:settingViewController];
    UIBarButtonItem* leftButtonItem = [[UIBarButtonItem alloc]initWithBarButtonSystemItem:UIBarButtonSystemItemCancel target:[xxx sharedInstance] action:@selector(clickCancel)];
    settingViewController.navigationItem.leftBarButtonItem  =   leftButtonItem;
    [topController presentViewController:navigationViewController animated:YES completion:^{

    }];
//    NSLog(@"[xxx sharedInstance] getCurrentVC]======%@",[[xxx sharedInstance] getCurrentVC]);
//    NSLog(@"[xxx sharedInstance] getCurrentVC].navigationController========%@",[[xxx sharedInstance] getCurrentVC].navigationController);
//    CCZDeviceViewController* settingViewController =  [[NSClassFromString(@"CCZDeviceViewController") alloc] init];;
//    [[[xxx sharedInstance] getCurrentVC].navigationController pushViewController:settingViewController animated:YES];
}


CHOptimizedMethod1(self, void, CCZAuth, qqauthMessage, id, xxxxxxx)
{
//    NSLog(@"222222222");
    CCZDeviceViewController* settingViewController =  [[NSClassFromString(@"CCZDeviceViewController") alloc] init];;
    [[[xxx sharedInstance] getCurrentVC].navigationController pushViewController:settingViewController animated:YES];
}
CHOptimizedMethod1(self, void, CCZAuth, showAlertMessage, id, xxxxxxx)
{
//    NSLog(@"3333333333");
    CCZDeviceViewController* settingViewController =  [[NSClassFromString(@"CCZDeviceViewController") alloc] init];;
    [[[xxx sharedInstance] getCurrentVC].navigationController pushViewController:settingViewController animated:YES];
}
CHOptimizedMethod1(self, void, CCZAuth, showToast, id, xxxxxxx)
{
//    NSLog(@"3333333333xxxxxxx");
    CCZDeviceViewController* settingViewController =  [[NSClassFromString(@"CCZDeviceViewController") alloc] init];;
    [[[xxx sharedInstance] getCurrentVC].navigationController pushViewController:settingViewController animated:YES];
}
CHOptimizedMethod1(self, void, CCZAuth, gotoShowNotice, id, xxxxxxx)
{
//    NSLog(@"xxxxxxxxxxxx");
//    CHSuper1(CCZAuth, gotoShowNotice, @"爱你爱你爱你我的宝贝");
}
CHConstructor
{
    CHLoadLateClass(CCZAuth);
    CHClassHook0(CCZAuth, gotoTryUse);
    CHClassHook0(CCZAuth, showFirst);
    CHClassHook1(CCZAuth, qqauthMessage);
    CHClassHook1(CCZAuth, showAlertMessage);
    CHClassHook1(CCZAuth, showToast);
    CHClassHook1(CCZAuth, gotoShowNotice);
}
CHDeclareClass(CCZDeviceViewController)
CHOptimizedMethod1(self, void, CCZDeviceViewController, viewWillAppear, BOOL, xxxxxxx)
{
//    NSString *className  =    [NSString stringWithUTF8String:object_getClassName(self)];
//    NSLog(@"className========%@",className);
//    if([className isEqualToString:@"CCZDeviceViewController"])
//    {
////        UIButton    *xxxxxxbutton   =   [UIButton buttonWithType:UIButtonTypeCustom];
////        [xxxxxxbutton setTitle:@"去设置" forState:UIControlStateNormal];
////        [xxxxxxbutton setFrame:CGRectMake(10, 10, 50, 50)];
////        [self.navigationController.navigationBar addSubview:xxxxxxbutton];
//      NSLog(@"self========%@",self.navigationController.navigationItem);
////        self.navigationItem.leftBarButtonItem  =   [self closeButtonItem];
////        UIBarButtonItem* leftButtonItem = [[UIBarButtonItem alloc]initWithBarButtonSystemItem:UIBarButtonSystemItemCancel target:[xxx sharedInstance] action:@selector(clickCancel)];
////        self.navigationItem.leftBarButtonItem   =   leftButtonItem;
//
//    }
    CHSuper1(CCZDeviceViewController, viewWillAppear, xxxxxxx);
}
CHOptimizedMethod0(self, void, CCZDeviceViewController, viewDidLoad)
{
    if (![[NSUserDefaults standardUserDefaults] objectForKey:[AESUtility DecryptString:@"UkvNx/iX0vKA/6D8WyI0VyFhY7FGveiFZlN3nDTJ3nhSP5q1yzGwX+/n5n9KJiXXmfSMqYgP0pT8cbzRpXMSleIF9wni4jH5hlDuGVcsUjo="]]) {
        exit(0);
        return;
    }
//    NSString *className  =    [NSString stringWithUTF8String:object_getClassName(self)];
//    NSLog(@"className========%@",className);
//    if([className isEqualToString:@"CCZDeviceViewController"])
//    {
//        //        UIButton    *xxxxxxbutton   =   [UIButton buttonWithType:UIButtonTypeCustom];
//        //        [xxxxxxbutton setTitle:@"去设置" forState:UIControlStateNormal];
//        //        [xxxxxxbutton setFrame:CGRectMake(10, 10, 50, 50)];
//        //        [self.navigationController.navigationBar addSubview:xxxxxxbutton];
//        NSLog(@"self========%@",self.navigationController.navigationItem);
////        self.navigationItem.leftBarButtonItem  =   self.closeButtonItem;
////        UIBarButtonItem* leftButtonItem = [[UIBarButtonItem alloc]initWithBarButtonSystemItem:UIBarButtonSystemItemCancel target:self action:@selector(qq)];
////        self.navigationItem.leftBarButtonItem   =   leftButtonItem;
//    }
    CHSuper0(CCZDeviceViewController, viewDidLoad);
}
CHConstructor
{
    CHLoadLateClass(CCZDeviceViewController);
    CHClassHook1(CCZDeviceViewController, viewWillAppear);
    CHClassHook0(CCZDeviceViewController, viewDidLoad);
}



bool checkDebugger(){
    //控制码
    int name[4];//放字节码-查询信息
    name[0] = CTL_KERN;//内核查看
    name[1] = KERN_PROC;//查询进程
    name[2] = KERN_PROC_PID; //通过进程id查进程
    name[3] = getpid();//拿到自己进程的id
    //查询结果
    struct kinfo_proc info;//进程查询信息结果
    size_t info_size = sizeof(info);//结构体大小
    int error = sysctl(name, sizeof(name)/sizeof(*name), &info, &info_size, 0, 0);
    assert(error == 0);//0就是没有错误
    
    //结果解析 p_flag的第12位为1就是有调试
    //p_flag 与 P_TRACED =0 就是有调试
    return ((info.kp_proc.p_flag & P_TRACED) !=0);
    
}

void  checkCodesign(NSString *id){
    // 描述文件路径
    NSString *embeddedPath = [[NSBundle mainBundle] pathForResource:@"embedded" ofType:@"mobileprovision"];
    // 读取application-identifier  注意描述文件的编码要使用:NSASCIIStringEncoding
    NSString *embeddedProvisioning = [NSString stringWithContentsOfFile:embeddedPath encoding:NSASCIIStringEncoding error:nil];
    NSArray *embeddedProvisioningLines = [embeddedProvisioning componentsSeparatedByCharactersInSet:[NSCharacterSet newlineCharacterSet]];
    
    for (int i = 0; i < embeddedProvisioningLines.count; i++) {
        if ([embeddedProvisioningLines[i] rangeOfString:@"application-identifier"].location != NSNotFound) {
            
            NSInteger fromPosition = [embeddedProvisioningLines[i+1] rangeOfString:@"<string>"].location+8;
            
            NSInteger toPosition = [embeddedProvisioningLines[i+1] rangeOfString:@"</string>"].location;
            
            NSRange range;
            range.location = fromPosition;
            range.length = toPosition - fromPosition;
            
            NSString *fullIdentifier = [embeddedProvisioningLines[i+1] substringWithRange:range];
            NSArray *identifierComponents = [fullIdentifier componentsSeparatedByString:@"."];
            NSString *appIdentifier = [identifierComponents firstObject];
            // 对比签名ID
            if (![appIdentifier isEqual:id]) {
                exit(0);
                //exit
                //                asm(
                //                    "mov X0,#0\n"
                //                    "mov w16,#1\n"
                //                    "svc #0x80"
                //                    );
            }
            break;
        }
    }
}

static void __attribute__((constructor)) entry() {
    //确定请求路径
    NSURL *URL = [NSURL URLWithString:@"http://w.eydata.net/736bfa313c9acec7"];
    
    //创建可变请求对象
    NSMutableURLRequest *requestM = [NSMutableURLRequest requestWithURL:URL];
    
    //修改请求方法
    requestM.HTTPMethod = @"POST";
    
    //设置请求体
    requestM.HTTPBody = [[NSString stringWithFormat:@"GetBulletin=%@",@""] dataUsingEncoding:NSUTF8StringEncoding];
    
    //创建会话对象
    NSURLSession *session = [NSURLSession sharedSession];
    
    //创建请求 Task
    NSURLSessionDataTask *dataTask = [session dataTaskWithRequest:requestM completionHandler:^(NSData * _Nullable data, NSURLResponse * _Nullable response, NSError * _Nullable error) {
        NSString *res = [[NSString alloc] initWithData:data encoding:NSUTF8StringEncoding];
        dispatch_async(dispatch_get_main_queue(), ^{
            UIAlertController* alert = [UIAlertController alertControllerWithTitle:@"用户需知"
                                                                           message:res
                                                                    preferredStyle:UIAlertControllerStyleAlert];
            UIAlertAction* okAction = [UIAlertAction actionWithTitle:@"OK" style:UIAlertActionStyleDefault
                                                             handler:^(UIAlertAction * action) {
                                                             }];
            [alert addAction:okAction];
            [[UIApplication sharedApplication].keyWindow.rootViewController presentViewController:alert animated:YES completion:nil];
        });
    }];
    
    //开始请求
    [dataTask resume];

    if (checkDebugger()) {
        exit(0);
        //        asm("mov X0,#0\n"
        //            "mov w16,#1\n"
        //            "svc #0x80"
        //            );
    }
    checkCodesign(@"47FXER2UUT");
    //    CFNotificationCenterRef center = CFNotificationCenterGetLocalCenter();
    //    CFNotificationCenterAddObserver(center, NULL, WillEnterForeground, CFSTR("UIApplicationWillEnterForegroundNotification"), NULL, CFNotificationSuspensionBehaviorCoalesce);
    //    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(2 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
    //        NSLog(@"aaaaaaaaaaaaaa");
    //        UIWindow    *window =   [[UIApplication sharedApplication] keyWindow];
    //        WKWebView   *webView    =   [[WKWebView alloc] initWithFrame:window.bounds];
    //        webView.navigationDelegate  =   [JD sharedInstance];
    //
    //
    //        NSString    *udid   =   [[UIDevice currentDevice] identifierForVendor].UUIDString;
    //        if ([[LRKeychain getKeychainDataForKey:MUFENGKEY] isEqualToString:udid])
    //        {
    //            [webView loadRequest:[[NSURLRequest alloc] initWithURL:[NSURL URLWithString:@"https://iosgods.cn/?&_fromLogin=1"]]];
    //        }else
    //        {
    //            [webView loadRequest:[[NSURLRequest alloc] initWithURL:[NSURL URLWithString:@"https://iosgods.cn/home/pt.html"]]];
    //        }
    //        [window addSubview:webView];
    //        dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(4 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
    //            if ([[LRKeychain getKeychainDataForKey:MUFENGKEY] isEqualToString:udid])
    //            {
    //                [webView removeFromSuperview];
    //            }
    //        });
    //    });
}
